/*
===== Safety Properties:
/*
There is never more than one train crossing the Gate (at
any time instance).
*/
A[] Train1.Cross + Train2.Cross + Train3.Cross + Train4.Cross <= 1

/*
There can never be N elements in the queue (thus the array will not overflow).
*/
A[] Queue.list[4] == 0

/*
===== Liveness Properties:
*/

/*
Whenever a train approaches the gate, it will eventually cross.
*/
Train1.Appr --> Train1.Cross

/*

*/
Train2.Appr --> Train2.Cross

/*

*/
Train3.Appr --> Train3.Cross

/*

*/
Train4.Appr --> Train4.Cross
